"""
##########################################
BlasterTK_LI module functions and members.

Developped for the Blaster plugin by:
	Daniel Barbeau Vasquez, copyright 2005
	Released under the GPL.
	V 0.75
	Inspired by Mariano's "Hotspots"
	script.
Handles OnSave, OnLoad events to 
dump/retreive data to/from harddrive.
##########################################
"""


import Blender
import pickle
import BlasterTK_FV
from Blender import Window, Scene, sys, Object, G

def make_save_name():
	scname = Scene.getCurrent().name
	savefile = sys.makename(Blender.Get("filename"), "_" + scname + ".blast", 0)
	return savefile

#picle version:
filename = make_save_name()


#OnSave script link
if Blender.event == "OnSave":
	LoadDict = {}
	LoadDict["Objects"] = {}
	LoadDict["Icons"] = {}
	for obj in G["SObj"].iterkeys():
		LoadDict["Objects"][obj] = dict()
		LoadDict["Objects"][obj]["icons"] = dict()
		for ico in G["SObj"][obj]["icons"]:
			ico = G["SObj"][obj]["icons"][ico]
			a = ico.getState()
			LoadDict["Objects"][obj]["icons"][ico.Name] = a
	for ico in G["Icons"].iterkeys():
		ico = G["Icons"][ico]
		a = ico.getState()
		LoadDict["Icons"][ico.Name] = a
			
	f = open(filename, "w")
	dump = LoadDict, G["Hbut"]
	pickle.dump(dump, f)
#OnLoad script link
elif Blender.event == "OnLoad":
	f = open(filename, "r")
	undump = pickle.load(f)
	BlasterTK_FV.modif_detect()
	#Loading Object_related icons
	for ob in undump[0]["Objects"].iterkeys():
		for ico in undump[0]["Objects"][ob]["icons"].iterkeys():
			G["SObj"][ob]["icons"][ico].setState(undump[0]["Objects"][ob]["icons"][ico])
	for ico in undump[0]["Icons"].iterkeys():
		G["Icons"][ico].setState(undump[0]["Icons"][ico])
	Window.QRedrawAll()
